package eg.marathon;

import fit.ActionFixture;
import fit.Parse;
import net.sourceforge.marathon.player.Marathon;
import net.sourceforge.marathon.tag.InvalidShirtException;
import net.sourceforge.marathon.tag.Tag;
import net.sourceforge.marathon.tag.AssertTag;
import net.sourceforge.marathon.tag.AssertTextTag;
import net.sourceforge.marathon.component.ComponentId;

import java.util.StringTokenizer;


public class MarathonFixture extends ActionFixture {
	private Marathon marathon = new Marathon();
	private net.sourceforge.marathon.player.Fixture fixture;

	public MarathonFixture() {
		marathon.windowOpenWaitTime = 1;
		marathon.delay = 1000;
	}

    public void window() throws Exception {
		marathon.window(getText(cells.more));
	}

	public void start() throws Exception {
		fixture = (net.sourceforge.marathon.player.Fixture) Class.forName(cells.more.text()).newInstance();
		fixture.setup();
	}

	public void enter() throws Exception {
		marathon.select(getComponent(), cells.more.more.text());
	}

	public void press() throws Exception {
		marathon.click(getComponent());
	}

	public void checkText() throws Exception {
		check(new AssertTextTag(getComponent(), getText(cells.more.more)));
	}

	public void checkEnabled() throws Exception {
		String text = getText(cells.more.more);
		boolean b = new Boolean(text).booleanValue();
		check(AssertTag.assertEnabled(getComponent(), b));
	}

	private void check(Tag assertTag) {
		try {
			assertTag.play(marathon.resolver, marathon.variableresolver);
			right(cells.more.more);
		} catch (InvalidShirtException e) {
			wrong(cells.more.more, e.getActual().toString());
		}
	}

	private ComponentId getComponent() {
		return new ComponentId(getText(cells.more));
	}

	private String getText(Parse cells) {
		StringTokenizer tokenizer = new StringTokenizer(cells.text(), " \t\r\n");
		if (!tokenizer.hasMoreTokens()) return "";
		String text = tokenizer.nextToken();
		while(tokenizer.hasMoreTokens()) {
			text += " " + tokenizer.nextToken();
		}
		return text;
	}

	public void stop() throws Exception {
		fixture.teardown();
	}

//	public void check() throws Exception {
//
//	}
}
