#$Id: marathon.py,v 1.2 2002/12/19 23:22:04 stellsmi Exp $

from net.sourceforge.marathon.recorder import WindowMonitor
from net.sourceforge.marathon.event import MySwingUtilities
from net.sourceforge.marathon.player import Fixture
from net.sourceforge.marathon.component import ComponentId
import java
import javax
import net

import sys

true = 1
false = 0

class Marathon(net.sourceforge.marathon.player.Marathon):
	def execTest(self,function):
		try:
			function.__call__()
		except:
			(exc_type, e, tb) = sys.exc_info()
			code = tb.tb_frame.f_code
			self.result.addFailure(e, code.co_filename, tb.tb_lineno, None)
		return

	def handleFailure(self, e):
		#right now, we don't do a full backtrace, just store the line number
		#and file where the call to failure happened. this of course won't be
		#sufficient for the future, but will be soooooo much more useful than
		#what came before. baby steps... baby steps...

		try:
			frame = self.__getframe(sys._getframe(0))
			code = frame.f_code
			marathon.result.addFailure(e.message, code.co_filename, frame.f_lineno, e.dataFileDetails)

		except Exception, e:
			print 'exception thrown from handleFailure:', e;

	def __getframe(self, frame):
#		print '     at ', frame.f_code.co_filename, ':', frame.f_lineno
		if frame.f_back == None or not frame.f_code.co_filename.endswith('marathon.py'):
			return frame
		else:
			return self.__getframe(frame.f_back)

marathon = Marathon()

def window(windowTitle):
	marathon.window(windowTitle)

def close():
	marathon.close()

def loadData(filename):
	marathon.loadData(filename)

def saveData():
	marathon.saveData()

def setVariable(name, value):
	marathon.setVariable(name, value)

def keystroke(keysequence):
	marathon.keystroke(keysequence)

def click(componentName, componentInfo=None):
	marathon.click(ComponentId(componentName, componentInfo))

def doubleclick(componentName, componentInfo=None):
	marathon.doubleclick(ComponentId(componentName, componentInfo))

def select(componentName, text, componentInfo=None):
	marathon.select(ComponentId(componentName, componentInfo), text)

def assertText(componentName, text, componentInfo=None):
	marathon.assertText(ComponentId(componentName, componentInfo), text)

def assertColor(componentName, color, componentInfo=None):
	marathon.assertColor(ComponentId(componentName, componentInfo), color)

def assertEnabled(componentName, enabled, componentInfo=None):
	marathon.assertEnabled(ComponentId(componentName, componentInfo), enabled)

def assertRowCount(componentName, rowCount, componentInfo=None):
	marathon.assertRowCount(ComponentId(componentName, componentInfo), rowCount)

def sleep(seconds):
	marathon.sleep(long(seconds))

def waitForWindowToOpen(windowTitle):
	marathon.waitForWindowToOpen(windowTitle)

def waitForWindowToClose(windowTitle):
	marathon.waitForWindowToClose(windowTitle)

def fail(message):
	marathon.fail(message)

def getText(componentName, componentInfo = None):
	return marathon.getText(ComponentId(componentName, componentInfo))