import sys

class Debugger:
	listener = None
	__lastfilename = None
	__lastlineno = None

	def trace(self, frame, event, arg):
		code = frame.f_code
		return self.__trace(code.co_name, code.co_filename, frame.f_lineno)

	def __trace(self, methodname, filename, lineno):
		if self.listener == None:
			return None

		if self.__isrepeat(filename, lineno) or self.__shouldignore(filename, lineno):
			return self.trace

		self.listener.aboutToExecute(methodname, filename, lineno)

		return self.trace

	def __isrepeat(self, filename, lineno):
		if self.__lastfilename == filename and self.__lastlineno == lineno:
			return 1
		else:
			self.__lastfilename = filename
			self.__lastlineno = lineno
			return 0

	def __shouldignore(self, filename, lineno):
		return filename == '<string>' or lineno == 0

debugger = Debugger()

sys.settrace(debugger.trace)
